﻿Imports C1.Win.C1FlexGrid
Imports System
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Data.OleDb
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports System.Windows.Forms
Imports System.Runtime.InteropServices
Public Class Form1
    <DllImport("user32")>
    Private Shared Function HideCaret(ByVal hWnd As IntPtr) As Boolean
    End Function
    Private _al As ArrayList = New ArrayList()
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Dim dt As DataTable = New DataTable()
        Dim connectionString As String = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & System.IO.Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments), "ComponentOne Samples\Common\C1NWind.mdb") & ";"
        Dim conn As OleDbConnection = New OleDbConnection(connectionString)
        Dim adapter As OleDbDataAdapter = New OleDbDataAdapter("Select * from Cars", conn)
        adapter.Fill(dt)
        C1FlexGrid1.DataSource = dt
        C1FlexGrid1.Rows.DefaultSize = 50
        C1FlexGrid1.Cols(12).AllowEditing = False

    End Sub

    Private Sub C1FlexGrid1_SelChange(sender As Object, e As EventArgs) Handles C1FlexGrid1.SelChange
        If C1FlexGrid1.Col = 12 Then
            Dim tbx As TextBox = New TextBox()
            tbx.Multiline = True
            tbx.ScrollBars = ScrollBars.Vertical
            tbx.ReadOnly = True
            AddHandler tbx.GotFocus, AddressOf Tbx_GotFocus
            tbx.Text = C1FlexGrid1(C1FlexGrid1.Row, C1FlexGrid1.Col).ToString()
            _al.Add(New HostedControl(C1FlexGrid1, tbx, C1FlexGrid1.Row, C1FlexGrid1.Col))
        End If
    End Sub

    Private Sub Tbx_GotFocus(ByVal sender As Object, ByVal e As EventArgs)
        Dim textBox1 As TextBox = TryCast(sender, TextBox)
        If textBox1.[ReadOnly] = True Then
            HideCaret(textBox1.Handle)
        End If
    End Sub
    Private Sub C1FlexGrid1_SetupEditor(sender As Object, e As RowColEventArgs) Handles C1FlexGrid1.SetupEditor
        Dim tb As TextBox = TryCast(C1FlexGrid1.Editor, TextBox)
        tb.Multiline = True
        tb.ScrollBars = ScrollBars.Vertical
    End Sub

    Private Sub C1FlexGrid1_Paint(sender As Object, e As PaintEventArgs) Handles C1FlexGrid1.Paint
        For Each hosted As HostedControl In _al
            hosted.UpdatePosition(C1FlexGrid1.Row, C1FlexGrid1.Col)
        Next
    End Sub
End Class
Friend Class HostedControl
    Friend _flex As C1FlexGrid
    Friend _ctl As Control
    Friend _row As Row
    Friend _col As Column

    Friend Sub New(ByVal flex As C1FlexGrid, ByVal hosted As Control, ByVal row As Integer, ByVal col As Integer)
        _flex = flex
        _ctl = hosted
        _row = flex.Rows(row)
        _col = flex.Cols(col)
        _flex.Controls.Add(_ctl)
    End Sub

    Friend Function UpdatePosition(ByVal row As Integer, ByVal col As Integer) As Boolean
        Dim r As Integer = _row.Index
        Dim c As Integer = _col.Index
        If r < 0 OrElse c < 0 Then Return False
        Dim rc As Rectangle = _flex.GetCellRect(r, c, False)

        If rc.Width <= 0 OrElse rc.Height <= 0 OrElse Not rc.IntersectsWith(_flex.ClientRectangle) OrElse row <> r OrElse col <> c Then
            _ctl.Visible = False
            Return True
        End If

        _ctl.Bounds = rc
        _ctl.Visible = True
        Return True
    End Function
End Class

